require 'multi_json'

require File.expand_path('../../../../../../../../lib/nucleo/models/feed_types/analytics/site/pages', __FILE__)

RSpec.describe(Nucleo::Models::FeedTypes::Analytics::Site::Pages, 'Pages with no data') do
  let(:model_attributes) do
    {
      "metrics" => [],
      "alerts"  => [],
      "changes" => [],
      "pages"   => []
    }
  end

  subject { described_class.new(model_attributes) }

  context "with empty values" do
    it "returns an empty Metric model for metric" do
      expect(subject.metric).to be_a(Nucleo::Models::Metric)
    end

    it "returns an empty MetricPeriodsTotals model for totals" do
      expect(subject.totals).to be_a(Nucleo::Models::MetricPeriodsTotals)
    end

    it "returns an empty MetricPeriod model for current_period" do
      expect(subject.current_period).to be_a(Nucleo::Models::MetricPeriod)
    end

    it "returns an empty MetricPeriod model for prior_period" do
      expect(subject.prior_period).to be_a(Nucleo::Models::MetricPeriod)
    end

    it "returns false for #any?" do
      expect(subject.any?).to be(false)
    end

  end
end
