
require 'multi_json'

require File.expand_path('../../../../../lib/nucleo/models/metric_periods_comparisons', __FILE__)

RSpec.describe(Nucleo::Models::MetricPeriodsComparisons) do
  let(:first_period_rows) do
    MultiJson.load('[{
      "ga:pageviews_rank": 1,
      "ga:source": "google",
      "ga:pageviews_pct_total": "0.743499",
      "ga:pageviews_rank_change": 0,
      "ga:pageviews": 3374,
      "ga:pageviews_change": "0.139597"
    },
    {
      "ga:pageviews_rank": 2,
      "ga:source": "forbes.com",
      "ga:pageviews_pct_total": "0.125606",
      "ga:pageviews_rank_change": 7,
      "ga:pageviews": 570,
      "ga:pageviews_change": "0.994737"
    }]')
  end

  let(:second_period_rows) do
    MultiJson.load('[{
      "ga:pageviews_rank": 1,
      "ga:pageviews": 2903,
      "ga:source": "google",
      "ga:pageviews_pct_total": "0.748775"
    },
    {
      "ga:pageviews_rank": 2,
      "ga:pageviews": 100,
      "ga:source": "bing",
      "ga:pageviews_pct_total": "0.025793"
    }]')
  end

  let(:first_period) do
    Nucleo::Models::MetricPeriod.new('metric' => 'ga:pageviews', 'dimension' => 'ga:source', 'period_name' => 'current', 'rows' => first_period_rows)
  end

  let(:second_period) do
    Nucleo::Models::MetricPeriod.new('metric' => 'ga:pageviews', 'dimension' => 'ga:source', 'period_name' => 'prior', 'rows' => second_period_rows)
  end

  subject { described_class.new(first_period, second_period) }

  context "with valid values" do
    it "returns a unique set of comparisons" do
      expected = 3
      expect(subject.count).to eq(expected)
    end

  end
end
